/***********************************************
 *
 * OG Script Dumper v2.5 by learn_more
 * File: out\a180\script\cam_dump.as
 * Generated: 31-May-2012 01:47:49
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b88f0 (0x7b88f0)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xbfbf0 (0x4bfbf0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xbfc20 (0x4bfc20)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b8d70 (0x7b8d70)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b94b0 (0x7b94b0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9240 (0x7b9240)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9130 (0x7b9130)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b9510 (0x7b9510)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b9000 (0x7b9000)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b8d20 (0x7b8d20)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b94e0 (0x7b94e0)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b8da0 (0x7b8da0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b8ed0 (0x7b8ed0)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b8940 (0x7b8940)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b8410 (0x7b8410)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24fff0 (0x64fff0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24ee70 (0x64ee70)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24eed0 (0x64eed0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24fe00 (0x64fe00)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24fe70 (0x64fe70)
	void Update();		// 'Overgrowth.exe' + 0x253ed0 (0x653ed0)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2ae700 (0x6ae700)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2ae6e0 (0x6ae6e0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37f6e0 (0x77f6e0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37f540 (0x77f540)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x37f4d0 (0x77f4d0)
	float GetLens();		// 'Overgrowth.exe' + 0x37f520 (0x77f520)
	void Update();		// 'Overgrowth.exe' + 0x37fb60 (0x77fb60)
	bool valid();		// 'Overgrowth.exe' + 0x37daa0 (0x77daa0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x20b14618
SphereCollision sphere_col;		// 0x20b1461c
GUI gui;		// 0x20b14be0
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x4369f0 (0x8369f0)
CameraObject co;		// 0x1c7ffe48
CameraAnimationReader camera_animation_reader;		// 0x1c7fff34
